import { b as createCommonjsModule, a as unwrapExports, e as _classCallCheck, f as _createClass } from './chunk-be6f7e39.js';
import { a as _inherits, b as _getPrototypeOf, c as _possibleConstructorReturn } from './chunk-d34a96fa.js';
import { a as _objectSpread } from './chunk-b17f0b50.js';
import React from 'react';
import PropTypes from 'prop-types';
import '@tao.js/core';
import './chunk-5ed574b8.js';
import 'cartesian';
import './chunk-51dbd58a.js';
import Adapter from './Adapter.js';

var objectWithoutPropertiesLoose = createCommonjsModule(function (module) {
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
module.exports = _objectWithoutPropertiesLoose, module.exports.__esModule = true, module.exports["default"] = module.exports;
});

unwrapExports(objectWithoutPropertiesLoose);

var objectWithoutProperties = createCommonjsModule(function (module) {
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
module.exports = _objectWithoutProperties, module.exports.__esModule = true, module.exports["default"] = module.exports;
});

var _objectWithoutProperties = unwrapExports(objectWithoutProperties);

var _excluded = ["adapter", "children"];
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
var DUMMY_STATE = {};
var Reactor = /*#__PURE__*/function (_React$Component) {
  _inherits(Reactor, _React$Component);
  function Reactor(props) {
    _classCallCheck(this, Reactor);
    return _callSuper(this, Reactor, [props]); // this._adapter = adapter;
  }
  _createClass(Reactor, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var adapter = this.props.adapter;
      adapter.registerReactor(this, this.onNotifyChange.bind(this));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var adapter = this.props.adapter;
      adapter && adapter.unregisterReactor && adapter.unregisterReactor(this);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var adapter = this.props.adapter;
      if (adapter !== prevProps.adapter) {
        prevProps.adapter.unregisterReactor(this);
        adapter.registerReactor(this, this.onNotifyChange.bind(this));
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return true;
    }
    //   // TODO: Implement this properly
    //   // CURRENTLY: this.props.adapter already has the changes after a TAO Handler
    //   const { adapter, children, ...props } = this.props;
    //   if (adapter !== nextProps.adapter) {
    //     return true;
    //   }
    //   if (
    //     (adapter.current == null && nextProps.adapter.current != null) ||
    //     (adapter.current != null && nextProps.adapter.current == null)
    //   ) {
    //     return true;
    //   }
    //   if (adapter.current == null && nextProps.adapter.current == null) {
    //     return false;
    //   }
    //   // TODO: if the term, action, orient or any other props change for the same
    //   //  Component, if this returns `false` will React still call render on the
    //   //  Component
    //   if (adapter.current.Component !== nextProps.adapter.current.Component) {
    //     return true;
    //   }
    //   // TODO: figure out if need to perform props equality check
    //   //  - by checking if updated props get sent to re-rendered child
    //   return false;
    // }
  }, {
    key: "onNotifyChange",
    value: function onNotifyChange() {
      this.setState(DUMMY_STATE);
    }
  }, {
    key: "render",
    value: function render() {
      // NOTE: Currently swallows any children
      var _this$props = this.props,
        adapter = _this$props.adapter,
        children = _this$props.children,
        props = _objectWithoutProperties(_this$props, _excluded);
      if (!adapter.current) {
        return null;
      }
      var _adapter$current = adapter.current,
        ComponentHandler = _adapter$current.ComponentHandler,
        tao = _adapter$current.tao,
        childProps = _adapter$current.props;
      if (!ComponentHandler) {
        return null;
      }
      return React.createElement(ComponentHandler, _objectSpread({}, tao, props, childProps));
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        adapter: PropTypes.instanceOf(Adapter).isRequired
      };
    }
  }]);
  return Reactor;
}(React.Component);

export default Reactor;
//# sourceMappingURL=Reactor.js.map
