import { e as _classCallCheck, g as _defineProperty, f as _createClass } from './chunk-be6f7e39.js';
import { a as _inherits, b as _getPrototypeOf, c as _possibleConstructorReturn, d as _assertThisInitialized } from './chunk-d34a96fa.js';
import { a as _objectSpread } from './chunk-b17f0b50.js';
import React from 'react';
import PropTypes from 'prop-types';
import { AppCtx } from '@tao.js/core';
import { Context } from './Provider.js';
import './chunk-5ed574b8.js';
import './chunk-8d541009.js';
import cartesian from 'cartesian';
import { b as normalizeClean, c as handlerHash } from './chunk-51dbd58a.js';
import RenderHandler from './RenderHandler.js';

function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
var SwitchHandler = /*#__PURE__*/function (_React$Component) {
  _inherits(SwitchHandler, _React$Component);
  function SwitchHandler(props) {
    var _this;
    _classCallCheck(this, SwitchHandler);
    _this = _callSuper(this, SwitchHandler, [props]);
    _defineProperty(_assertThisInitialized(_this), "handleClear", function (tao, data) {
      var _this$props$debug = _this.props.debug,
        debug = _this$props$debug === void 0 ? false : _this$props$debug;
      debug && console.log('SwitchHandler::handleClear:', {
        tao: tao,
        data: data
      });
      var chosenList = new Set();
      _this.setState({
        chosenList: chosenList
      });
    });
    _defineProperty(_assertThisInitialized(_this), "handleSwitch", function (childHash) {
      return function (tao, data) {
        var _this$props$debug2 = _this.props.debug,
          debug = _this$props$debug2 === void 0 ? false : _this$props$debug2;
        debug && console.log('SwitchHandler::handleSwitch:', {
          tao: tao,
          data: data
        });
        var chosenList = _this.state.chosenList;
        debug && console.log('chosenList:', chosenList);
        chosenList.add(childHash);
        _this.setState({
          chosenList: chosenList
        });
        debug && console.log('SwitchHandler::handleSwitch::set state with:', _this.state);
      };
    });
    _this._adaptedChildren = new Map();
    _this.state = {
      chosenList: new Set()
    };
    return _this;
  }
  _createClass(SwitchHandler, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      var _this$props$debug3 = this.props.debug,
        debug = _this$props$debug3 === void 0 ? false : _this$props$debug3;
      debug && console.log('SwitchHandler::componentDidMount::props:', this.props);
      var TAO = this.context.TAO;
      var defaultTrigram = normalizeClean(this.props);
      var intercepted = new Map();
      React.Children.forEach(this.props.children, function (child, i) {
        if (child.type === RenderHandler) {
          var childTrigram = normalizeClean(child.props);
          var childHash = handlerHash(childTrigram);
          var handler = _this2.handleSwitch(childHash);
          var trigrams = Object.assign(defaultTrigram, childTrigram);
          debug && console.log('trigrams:', trigrams);
          var permutations = cartesian(trigrams);
          debug && console.log('permutations:', permutations);
          _this2._adaptedChildren.set(child, {
            permutations: permutations,
            handler: handler
          });
          permutations.forEach(function (trigram) {
            var ac = new AppCtx(trigram.term, trigram.action, trigram.orient);
            TAO.addInlineHandler(trigram, handler);
            if (!intercepted.has(ac.key)) {
              TAO.addInterceptHandler(trigram, _this2.handleClear);
              intercepted.set(ac.key, true);
            }
          });
        }
      });
      debug && console.log('SwitchHandler::componentDidMount::complete:', {
        intercepted: intercepted,
        adaptedChildren: this._adaptedChildren
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this3 = this;
      var TAO = this.context.TAO;
      this._adaptedChildren.forEach(function (_ref, child) {
        var permutations = _ref.permutations,
          handler = _ref.handler;
        permutations.forEach(function (trigram) {
          TAO.removeInlineHandler(trigram, handler);
          TAO.removeInterceptHandler(trigram, _this3.handleClear);
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props$debug4 = this.props.debug,
        debug = _this$props$debug4 === void 0 ? false : _this$props$debug4;
      debug && console.log('SwitchHandler::render::state:', this.state);
      var _this$props = this.props,
        term = _this$props.term,
        action = _this$props.action,
        orient = _this$props.orient,
        children = _this$props.children;
      var chosenList = this.state.chosenList;
      return React.Children.map(children, function (child) {
        if (!React.isValidElement(child) || child.type !== RenderHandler) {
          debug && console.log('SwitchHandler::render:returning child');
          return child;
        }
        debug && console.log('SwitchHandler::render:testing child');
        var childHash = handlerHash(normalizeClean(child.props));
        if (chosenList.has(childHash)) {
          debug && console.log('SwitchHandler::render:cloning child');
          return React.cloneElement(child, _objectSpread({
            term: term,
            action: action,
            orient: orient
          }, child.props));
        }
      });
    }
  }]);
  return SwitchHandler;
}(React.Component);
_defineProperty(SwitchHandler, "contextType", Context);
_defineProperty(SwitchHandler, "propTypes", {
  term: PropTypes.any,
  action: PropTypes.any,
  orient: PropTypes.any,
  debug: PropTypes.bool,
  children: PropTypes.node.isRequired
});

export default SwitchHandler;
//# sourceMappingURL=SwitchHandler.js.map
