import { e as _classCallCheck, g as _defineProperty, f as _createClass } from './chunk-be6f7e39.js';
import { a as _inherits, b as _getPrototypeOf, c as _possibleConstructorReturn, d as _assertThisInitialized } from './chunk-d34a96fa.js';
import React from 'react';
import { AppCtx } from '@tao.js/core';
import { Context } from './Provider.js';
import { a as _toConsumableArray } from './chunk-8d541009.js';
import { a as getPermutations } from './chunk-51dbd58a.js';

function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function cleanState(previousState, newState) {
  var keys = Object.keys(previousState);
  if (newState == null) {
    return keys.reduce(function (rv, key) {
      rv[key] = void 0;
      return rv;
    }, {});
  }
  keys.push.apply(keys, _toConsumableArray(Object.keys(newState)));
  return keys.reduce(function (rv, key) {
    rv[key] = newState[key];
    return rv;
  }, {});
}
function createContextHandler(tao, handler, defaultValue) {
  if (handler != null && typeof handler !== 'function') {
    throw new Error('createContextHandler `handler` must be a function');
  }
  var WrappingContext = React.createContext(defaultValue);
  var Provider = /*#__PURE__*/function (_React$Component) {
    _inherits(Provider, _React$Component);
    function Provider(props) {
      var _this;
      _classCallCheck(this, Provider);
      _this = _callSuper(this, Provider, [props]);
      _defineProperty(_assertThisInitialized(_this), "contextHandler", function (tao, data) {
        var usedSet = false;
        var current = _this.state;
        var dataUpdate = handler ? handler(tao, data, function (data) {
          var update = cleanState(current, data);
          _this.setState(update);
          usedSet = true;
        }, current) : data;
        if (dataUpdate instanceof AppCtx) {
          return dataUpdate;
        }
        if (!usedSet && dataUpdate != null) {
          _this.setState(dataUpdate);
        }
      });
      _this.state = typeof defaultValue === 'function' ? defaultValue() : defaultValue || {};
      return _this;
    }
    _createClass(Provider, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this2 = this;
        var TAO = this.context.TAO;
        var permutations = getPermutations(tao);
        permutations.forEach(function (trigram) {
          return TAO.addInlineHandler(trigram, _this2.contextHandler);
        });
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        var _this3 = this;
        var TAO = this.context.TAO;
        var permutations = getPermutations(tao);
        permutations.forEach(function (trigram) {
          return TAO.removeInlineHandler(trigram, _this3.contextHandler);
        });
      }
    }, {
      key: "render",
      value: function render() {
        return /*#__PURE__*/React.createElement(WrappingContext.Provider, {
          value: this.state
        }, this.props.children);
      }
    }]);
    return Provider;
  }(React.Component);
  _defineProperty(Provider, "contextType", Context);
  return {
    Provider: Provider,
    Consumer: WrappingContext.Consumer
  };
}

export { createContextHandler as a };
//# sourceMappingURL=chunk-1952bec6.js.map
