import cartesian from 'cartesian';

var noop = function noop() {};
function normalizeAC(_ref) {
  var t = _ref.t,
    term = _ref.term,
    a = _ref.a,
    action = _ref.action,
    o = _ref.o,
    orient = _ref.orient;
  return {
    term: term || t,
    action: action || a,
    orient: orient || o
  };
}
function cleanInput(_ref2) {
  var term = _ref2.term,
    action = _ref2.action,
    orient = _ref2.orient;
  var incoming = {
    term: term,
    action: action,
    orient: orient
  };
  Object.keys(incoming).forEach(function (k) {
    return incoming[k] == null && delete incoming[k];
  });
  return incoming;
}
function normalizeClean(_ref3) {
  var t = _ref3.t,
    term = _ref3.term,
    a = _ref3.a,
    action = _ref3.action,
    o = _ref3.o,
    orient = _ref3.orient;
  return cleanInput(normalizeAC({
    t: t,
    term: term,
    a: a,
    action: action,
    o: o,
    orient: orient
  }));
}
function getPermutations(_ref4) {
  var t = _ref4.t,
    term = _ref4.term,
    a = _ref4.a,
    action = _ref4.action,
    o = _ref4.o,
    orient = _ref4.orient;
  var trigram = normalizeClean({
    t: t,
    term: term,
    a: a,
    action: action,
    o: o,
    orient: orient
  });
  var permutations = cartesian(trigram);
  if (permutations.length) {
    return permutations;
  }
  return [{}];
}
function trigramHash(trigram) {
  return !trigram ? '%' : Array.isArray(trigram) ? trigram.join(',') : trigram;
}
function handlerHash(_ref5) {
  var term = _ref5.term,
    action = _ref5.action,
    orient = _ref5.orient;
  return "".concat(trigramHash(term), "|").concat(trigramHash(action), "|").concat(trigramHash(orient));
}

export { getPermutations as a, normalizeClean as b, handlerHash as c, noop as d };
//# sourceMappingURL=chunk-51dbd58a.js.map
