import { e as _classCallCheck, f as _createClass, g as _defineProperty } from './chunk-be6f7e39.js';
import { a as _inherits, b as _getPrototypeOf, c as _possibleConstructorReturn } from './chunk-d34a96fa.js';
import './chunk-b17f0b50.js';
import React from 'react';
import PropTypes from 'prop-types';
import '@tao.js/core';
import { Context } from './Provider.js';
export { default as Provider } from './Provider.js';
import './chunk-5ed574b8.js';
import { a as _toConsumableArray } from './chunk-8d541009.js';
import 'cartesian';
import { a as getPermutations } from './chunk-51dbd58a.js';
export { a as createContextHandler } from './chunk-1952bec6.js';
export { default as DataHandler } from './DataHandler.js';
export { default as RenderHandler } from './RenderHandler.js';
export { default as SwitchHandler } from './SwitchHandler.js';
export { default as withContext } from './withContext.js';
export { default as Adapter } from './Adapter.js';
export { default as Reactor } from './Reactor.js';

function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function recursiveContextGenerator(ctxList, getContext, children) {
  var ctxIdx = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
  var ctxDataArgs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
  if (ctxDataArgs == null) {
    ctxDataArgs = new Array(ctxList.length);
  }
  var ctxName = ctxList[ctxIdx];
  var context = getContext(ctxName);
  if (!context) {
    console.warn("DataConsumer::Unable to find context for '".concat(ctxName, "'. Please check that you have it spelled correctly."));
    console.info("DataConsumer::setting context ".concat(ctxName, " data arg to null"));
    ctxDataArgs[ctxIdx] = null;
    return recursiveContextGenerator(ctxList, getContext, children, ctxIdx + 1, ctxDataArgs);
  }
  if (ctxList.length > ctxIdx + 1) {
    return /*#__PURE__*/React.createElement(context.Consumer, {
      name: "".concat(ctxName, ".Consumer")
    }, function (ctxData) {
      ctxDataArgs[ctxIdx] = ctxData;
      return recursiveContextGenerator(ctxList, getContext, children, ctxIdx + 1, ctxDataArgs);
    });
  }
  return /*#__PURE__*/React.createElement(context.Consumer, {
    name: "".concat(ctxName, ".Consumer")
  }, function (ctxData) {
    ctxDataArgs[ctxIdx] = ctxData;
    return children.apply(void 0, _toConsumableArray(ctxDataArgs));
  });
}
var DataConsumer = /*#__PURE__*/function (_React$Component) {
  _inherits(DataConsumer, _React$Component);
  function DataConsumer() {
    _classCallCheck(this, DataConsumer);
    return _callSuper(this, DataConsumer, arguments);
  }
  _createClass(DataConsumer, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        context = _this$props.context,
        children = _this$props.children;
      var getDataContext = this.context.getDataContext;
      var ctxList = Array.isArray(context) ? context : [context];
      return recursiveContextGenerator(ctxList, getDataContext, children);
    }
  }]);
  return DataConsumer;
}(React.Component);
_defineProperty(DataConsumer, "contextType", Context);
_defineProperty(DataConsumer, "propTypes", {
  context: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]).isRequired,
  children: PropTypes.func.isRequired
});

function useTaoContext() {
  var _React$useContext = React.useContext(Context),
    TAO = _React$useContext.TAO;
  return TAO;
}
function useTaoEffect(handlerType, _ref, handler, dependencies) {
  var t = _ref.t,
    term = _ref.term,
    a = _ref.a,
    action = _ref.action,
    o = _ref.o,
    orient = _ref.orient;
  var addingHandler = "add".concat(handlerType, "Handler"),
    removingHandler = "remove".concat(handlerType, "Handler");
  var TAO = useTaoContext();
  var permutations = getPermutations({
    t: t,
    term: term,
    a: a,
    action: action,
    o: o,
    orient: orient
  });
  React.useEffect(function () {
    permutations.forEach(function (trigram) {
      return TAO[addingHandler](trigram, handler);
    });
    return function () {
      permutations.forEach(function (trigram) {
        return TAO[removingHandler](trigram, handler);
      });
    };
  }, dependencies);
}
function useTaoInlineHandler(_ref2, handler, dependencies) {
  var t = _ref2.t,
    term = _ref2.term,
    a = _ref2.a,
    action = _ref2.action,
    o = _ref2.o,
    orient = _ref2.orient;
  useTaoEffect('Inline', {
    t: t,
    term: term,
    a: a,
    action: action,
    o: o,
    orient: orient
  }, handler, dependencies);
}
function useTaoAsyncHandler(_ref3, handler, dependencies) {
  var t = _ref3.t,
    term = _ref3.term,
    a = _ref3.a,
    action = _ref3.action,
    o = _ref3.o,
    orient = _ref3.orient;
  useTaoEffect('Async', {
    t: t,
    term: term,
    a: a,
    action: action,
    o: o,
    orient: orient
  }, handler, dependencies);
}
function useTaoInterceptHandler(_ref4, handler, dependencies) {
  var t = _ref4.t,
    term = _ref4.term,
    a = _ref4.a,
    action = _ref4.action,
    o = _ref4.o,
    orient = _ref4.orient;
  useTaoEffect('Intercept', {
    t: t,
    term: term,
    a: a,
    action: action,
    o: o,
    orient: orient
  }, handler, dependencies);
}
function useTaoDataContext(name) {
  var _React$useContext2 = React.useContext(Context),
    getDataContext = _React$useContext2.getDataContext;
  var dataContext = getDataContext(name);
  if (!dataContext) {
    return;
  }
  return React.useContext(dataContext);
}

export { DataConsumer, useTaoAsyncHandler, useTaoContext, useTaoDataContext, useTaoInlineHandler, useTaoInterceptHandler };
//# sourceMappingURL=index.js.map
