'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-24c7247e.js');
var __chunk_2 = require('./chunk-92da5585.js');
var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
require('@tao.js/core');
var Provider = require('./Provider.js');
var __chunk_3 = require('./chunk-7af7c951.js');
var cartesian = _interopDefault(require('cartesian'));
var __chunk_4 = require('./chunk-3e248644.js');

function _callSuper(t, o, e) { return o = __chunk_1._getPrototypeOf(o), __chunk_1._possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], __chunk_1._getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function recursiveContextGenerator(ctxList, getContext, children, tao, data) {
  var ctxIdx = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;
  var ctxDataArgs = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : null;
  if (ctxDataArgs == null) {
    ctxDataArgs = new Array(ctxList.length);
  }
  var ctxName = ctxList[ctxIdx];
  var context = getContext(ctxName);
  if (!context) {
    console.warn("RenderHandler::Unable to find context for '".concat(ctxName, "'. Please check that you have it spelled correctly."));
    console.info("RenderHandler::setting context ".concat(ctxName, " data arg to null"));
    ctxDataArgs[ctxIdx] = null;
    return recursiveContextGenerator(ctxList, getContext, children, tao, data, ctxIdx + 1, ctxDataArgs);
  }
  if (ctxList.length > ctxIdx + 1) {
    return /*#__PURE__*/React.createElement(context.Consumer, {
      name: "".concat(ctxName, ".Consumer")
    }, function (ctxData) {
      ctxDataArgs[ctxIdx] = ctxData;
      return recursiveContextGenerator(ctxList, getContext, children, tao, data, ctxIdx + 1, ctxDataArgs);
    });
  }
  return /*#__PURE__*/React.createElement(context.Consumer, {
    name: "".concat(ctxName, ".Consumer")
  }, function (ctxData) {
    ctxDataArgs[ctxIdx] = ctxData;
    return children.apply(void 0, [tao, data].concat(__chunk_3._toConsumableArray(ctxDataArgs)));
  });
}
var RenderHandler = /*#__PURE__*/function (_React$Component) {
  __chunk_1._inherits(RenderHandler, _React$Component);
  function RenderHandler(props) {
    var _this;
    __chunk_1._classCallCheck(this, RenderHandler);
    _this = _callSuper(this, RenderHandler, [props]);
    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(_this), "handleRender", function (tao, data) {
      // TODO: allow shouldRender prop be a function called
      _this.setState({
        tao: tao,
        data: data,
        shouldRender: true
      });
    });
    var shouldRender = props.shouldRender;
    shouldRender = typeof shouldRender === 'undefined' ? false : shouldRender;
    _this.state = {
      shouldRender: shouldRender
    };
    _this._refreshOn = null;
    return _this;
  }
  __chunk_1._createClass(RenderHandler, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      var _this$props$debug = this.props.debug,
        debug = _this$props$debug === void 0 ? false : _this$props$debug;
      debug && console.log('RenderHandler::props:', this.props);
      debug && console.log('RenderHandler::context:', this.context);
      var TAO = this.context.TAO;
      var permutations = __chunk_4.getPermutations(this.props);
      if (permutations.length) {
        permutations.forEach(function (_ref) {
          var term = _ref.term,
            action = _ref.action,
            orient = _ref.orient;
          return TAO.addInlineHandler({
            term: term,
            action: action,
            orient: orient
          }, _this2.handleRender);
        });
      }
      var refreshOn = this.props.refreshOn;
      if (refreshOn) {
        var trigram = __chunk_4.normalizeClean(this.props);
        var refresh = __chunk_4.normalizeClean(refreshOn);
        if (!Object.keys(refresh).length) {
          return;
        }
        this._refreshOn = cartesian(__chunk_2._objectSpread({}, trigram, refresh));
        this._refreshOn.forEach(function (_ref2) {
          var term = _ref2.term,
            action = _ref2.action,
            orient = _ref2.orient;
          return TAO.addInlineHandler({
            term: term,
            action: action,
            orient: orient
          }, _this2.handleRender);
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this3 = this;
      var TAO = this.context.TAO;
      var permutations = __chunk_4.getPermutations(this.props);
      if (permutations.length) {
        permutations.forEach(function (_ref3) {
          var term = _ref3.term,
            action = _ref3.action,
            orient = _ref3.orient;
          return TAO.removeInlineHandler({
            term: term,
            action: action,
            orient: orient
          }, _this3.handleRender);
        });
      }
      if (this._refreshOn && this._refreshOn.length) {
        this._refreshOn.forEach(function (_ref4) {
          var term = _ref4.term,
            action = _ref4.action,
            orient = _ref4.orient;
          return TAO.removeInlineHandler({
            term: term,
            action: action,
            orient: orient
          }, _this3.handleRender);
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        context = _this$props.context,
        children = _this$props.children;
      var _this$state = this.state,
        shouldRender = _this$state.shouldRender,
        tao = _this$state.tao,
        data = _this$state.data;
      var getDataContext = this.context.getDataContext;
      if (!shouldRender) {
        return null;
      }
      if (!context) {
        return /*#__PURE__*/React.createElement(React.Fragment, null, children(tao, data));
      }
      var ctxList = Array.isArray(context) ? context : [context];
      return recursiveContextGenerator(ctxList, getDataContext, children, tao, data);
    }
  }]);
  return RenderHandler;
}(React.Component);
__chunk_1._defineProperty(RenderHandler, "contextType", Provider.Context);
__chunk_1._defineProperty(RenderHandler, "propTypes", {
  term: PropTypes.any,
  action: PropTypes.any,
  orient: PropTypes.any,
  context: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]),
  debug: PropTypes.bool,
  children: PropTypes.func.isRequired
});

exports.default = RenderHandler;
//# sourceMappingURL=RenderHandler.js.map
