'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-24c7247e.js');
var __chunk_2 = require('./chunk-92da5585.js');
var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var TAO = require('@tao.js/core');
var TAO__default = _interopDefault(TAO);
var Provider = require('./Provider.js');
require('./chunk-7af7c951.js');
var cartesian = _interopDefault(require('cartesian'));
var __chunk_4 = require('./chunk-3e248644.js');
var RenderHandler = require('./RenderHandler.js');

function _callSuper(t, o, e) { return o = __chunk_1._getPrototypeOf(o), __chunk_1._possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], __chunk_1._getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
var SwitchHandler = /*#__PURE__*/function (_React$Component) {
  __chunk_1._inherits(SwitchHandler, _React$Component);
  function SwitchHandler(props) {
    var _this;
    __chunk_1._classCallCheck(this, SwitchHandler);
    _this = _callSuper(this, SwitchHandler, [props]);
    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(_this), "handleClear", function (tao, data) {
      var _this$props$debug = _this.props.debug,
        debug = _this$props$debug === void 0 ? false : _this$props$debug;
      debug && console.log('SwitchHandler::handleClear:', {
        tao: tao,
        data: data
      });
      var chosenList = new Set();
      _this.setState({
        chosenList: chosenList
      });
    });
    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(_this), "handleSwitch", function (childHash) {
      return function (tao, data) {
        var _this$props$debug2 = _this.props.debug,
          debug = _this$props$debug2 === void 0 ? false : _this$props$debug2;
        debug && console.log('SwitchHandler::handleSwitch:', {
          tao: tao,
          data: data
        });
        var chosenList = _this.state.chosenList;
        debug && console.log('chosenList:', chosenList);
        chosenList.add(childHash);
        _this.setState({
          chosenList: chosenList
        });
        debug && console.log('SwitchHandler::handleSwitch::set state with:', _this.state);
      };
    });
    _this._adaptedChildren = new Map();
    _this.state = {
      chosenList: new Set()
    };
    return _this;
  }
  __chunk_1._createClass(SwitchHandler, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      var _this$props$debug3 = this.props.debug,
        debug = _this$props$debug3 === void 0 ? false : _this$props$debug3;
      debug && console.log('SwitchHandler::componentDidMount::props:', this.props);
      var TAO$1 = this.context.TAO;
      var defaultTrigram = __chunk_4.normalizeClean(this.props);
      var intercepted = new Map();
      React.Children.forEach(this.props.children, function (child, i) {
        if (child.type === RenderHandler.default) {
          var childTrigram = __chunk_4.normalizeClean(child.props);
          var childHash = __chunk_4.handlerHash(childTrigram);
          var handler = _this2.handleSwitch(childHash);
          var trigrams = Object.assign(defaultTrigram, childTrigram);
          debug && console.log('trigrams:', trigrams);
          var permutations = cartesian(trigrams);
          debug && console.log('permutations:', permutations);
          _this2._adaptedChildren.set(child, {
            permutations: permutations,
            handler: handler
          });
          permutations.forEach(function (trigram) {
            var ac = new TAO.AppCtx(trigram.term, trigram.action, trigram.orient);
            TAO$1.addInlineHandler(trigram, handler);
            if (!intercepted.has(ac.key)) {
              TAO$1.addInterceptHandler(trigram, _this2.handleClear);
              intercepted.set(ac.key, true);
            }
          });
        }
      });
      debug && console.log('SwitchHandler::componentDidMount::complete:', {
        intercepted: intercepted,
        adaptedChildren: this._adaptedChildren
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this3 = this;
      var TAO = this.context.TAO;
      this._adaptedChildren.forEach(function (_ref, child) {
        var permutations = _ref.permutations,
          handler = _ref.handler;
        permutations.forEach(function (trigram) {
          TAO.removeInlineHandler(trigram, handler);
          TAO.removeInterceptHandler(trigram, _this3.handleClear);
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props$debug4 = this.props.debug,
        debug = _this$props$debug4 === void 0 ? false : _this$props$debug4;
      debug && console.log('SwitchHandler::render::state:', this.state);
      var _this$props = this.props,
        term = _this$props.term,
        action = _this$props.action,
        orient = _this$props.orient,
        children = _this$props.children;
      var chosenList = this.state.chosenList;
      return React.Children.map(children, function (child) {
        if (!React.isValidElement(child) || child.type !== RenderHandler.default) {
          debug && console.log('SwitchHandler::render:returning child');
          return child;
        }
        debug && console.log('SwitchHandler::render:testing child');
        var childHash = __chunk_4.handlerHash(__chunk_4.normalizeClean(child.props));
        if (chosenList.has(childHash)) {
          debug && console.log('SwitchHandler::render:cloning child');
          return React.cloneElement(child, __chunk_2._objectSpread({
            term: term,
            action: action,
            orient: orient
          }, child.props));
        }
      });
    }
  }]);
  return SwitchHandler;
}(React.Component);
__chunk_1._defineProperty(SwitchHandler, "contextType", Provider.Context);
__chunk_1._defineProperty(SwitchHandler, "propTypes", {
  term: PropTypes.any,
  action: PropTypes.any,
  orient: PropTypes.any,
  debug: PropTypes.bool,
  children: PropTypes.node.isRequired
});

exports.default = SwitchHandler;
//# sourceMappingURL=SwitchHandler.js.map
