'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-24c7247e.js');
var React = _interopDefault(require('react'));
var TAO = require('@tao.js/core');
var TAO__default = _interopDefault(TAO);
var Provider = require('./Provider.js');
var __chunk_3 = require('./chunk-7af7c951.js');
var __chunk_4 = require('./chunk-3e248644.js');

function _callSuper(t, o, e) { return o = __chunk_1._getPrototypeOf(o), __chunk_1._possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], __chunk_1._getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function cleanState(previousState, newState) {
  var keys = Object.keys(previousState);
  if (newState == null) {
    return keys.reduce(function (rv, key) {
      rv[key] = void 0;
      return rv;
    }, {});
  }
  keys.push.apply(keys, __chunk_3._toConsumableArray(Object.keys(newState)));
  return keys.reduce(function (rv, key) {
    rv[key] = newState[key];
    return rv;
  }, {});
}
function createContextHandler(tao, handler, defaultValue) {
  if (handler != null && typeof handler !== 'function') {
    throw new Error('createContextHandler `handler` must be a function');
  }
  var WrappingContext = React.createContext(defaultValue);
  var Provider$1 = /*#__PURE__*/function (_React$Component) {
    __chunk_1._inherits(Provider, _React$Component);
    function Provider(props) {
      var _this;
      __chunk_1._classCallCheck(this, Provider);
      _this = _callSuper(this, Provider, [props]);
      __chunk_1._defineProperty(__chunk_1._assertThisInitialized(_this), "contextHandler", function (tao, data) {
        var usedSet = false;
        var current = _this.state;
        var dataUpdate = handler ? handler(tao, data, function (data) {
          var update = cleanState(current, data);
          _this.setState(update);
          usedSet = true;
        }, current) : data;
        if (dataUpdate instanceof TAO.AppCtx) {
          return dataUpdate;
        }
        if (!usedSet && dataUpdate != null) {
          _this.setState(dataUpdate);
        }
      });
      _this.state = typeof defaultValue === 'function' ? defaultValue() : defaultValue || {};
      return _this;
    }
    __chunk_1._createClass(Provider, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this2 = this;
        var TAO = this.context.TAO;
        var permutations = __chunk_4.getPermutations(tao);
        permutations.forEach(function (trigram) {
          return TAO.addInlineHandler(trigram, _this2.contextHandler);
        });
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        var _this3 = this;
        var TAO = this.context.TAO;
        var permutations = __chunk_4.getPermutations(tao);
        permutations.forEach(function (trigram) {
          return TAO.removeInlineHandler(trigram, _this3.contextHandler);
        });
      }
    }, {
      key: "render",
      value: function render() {
        return /*#__PURE__*/React.createElement(WrappingContext.Provider, {
          value: this.state
        }, this.props.children);
      }
    }]);
    return Provider;
  }(React.Component);
  __chunk_1._defineProperty(Provider$1, "contextType", Provider.Context);
  return {
    Provider: Provider$1,
    Consumer: WrappingContext.Consumer
  };
}

exports.createContextHandler = createContextHandler;
//# sourceMappingURL=chunk-76986848.js.map
