'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-24c7247e.js');
require('./chunk-92da5585.js');
var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
require('@tao.js/core');
var Provider = require('./Provider.js');
var __chunk_3 = require('./chunk-7af7c951.js');
require('cartesian');
var __chunk_4 = require('./chunk-3e248644.js');
var __chunk_5 = require('./chunk-76986848.js');
var DataHandler = require('./DataHandler.js');
var RenderHandler = require('./RenderHandler.js');
var SwitchHandler = require('./SwitchHandler.js');
var withContext = require('./withContext.js');

function _callSuper(t, o, e) { return o = __chunk_1._getPrototypeOf(o), __chunk_1._possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], __chunk_1._getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function recursiveContextGenerator(ctxList, getContext, children) {
  var ctxIdx = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
  var ctxDataArgs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
  if (ctxDataArgs == null) {
    ctxDataArgs = new Array(ctxList.length);
  }
  var ctxName = ctxList[ctxIdx];
  var context = getContext(ctxName);
  if (!context) {
    console.warn("DataConsumer::Unable to find context for '".concat(ctxName, "'. Please check that you have it spelled correctly."));
    console.info("DataConsumer::setting context ".concat(ctxName, " data arg to null"));
    ctxDataArgs[ctxIdx] = null;
    return recursiveContextGenerator(ctxList, getContext, children, ctxIdx + 1, ctxDataArgs);
  }
  if (ctxList.length > ctxIdx + 1) {
    return /*#__PURE__*/React.createElement(context.Consumer, {
      name: "".concat(ctxName, ".Consumer")
    }, function (ctxData) {
      ctxDataArgs[ctxIdx] = ctxData;
      return recursiveContextGenerator(ctxList, getContext, children, ctxIdx + 1, ctxDataArgs);
    });
  }
  return /*#__PURE__*/React.createElement(context.Consumer, {
    name: "".concat(ctxName, ".Consumer")
  }, function (ctxData) {
    ctxDataArgs[ctxIdx] = ctxData;
    return children.apply(void 0, __chunk_3._toConsumableArray(ctxDataArgs));
  });
}
var DataConsumer = /*#__PURE__*/function (_React$Component) {
  __chunk_1._inherits(DataConsumer, _React$Component);
  function DataConsumer() {
    __chunk_1._classCallCheck(this, DataConsumer);
    return _callSuper(this, DataConsumer, arguments);
  }
  __chunk_1._createClass(DataConsumer, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        context = _this$props.context,
        children = _this$props.children;
      var getDataContext = this.context.getDataContext;
      var ctxList = Array.isArray(context) ? context : [context];
      return recursiveContextGenerator(ctxList, getDataContext, children);
    }
  }]);
  return DataConsumer;
}(React.Component);
__chunk_1._defineProperty(DataConsumer, "contextType", Provider.Context);
__chunk_1._defineProperty(DataConsumer, "propTypes", {
  context: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]).isRequired,
  children: PropTypes.func.isRequired
});

function useTaoContext() {
  var _React$useContext = React.useContext(Provider.Context),
    TAO = _React$useContext.TAO;
  return TAO;
}
function useTaoEffect(handlerType, _ref, handler, dependencies) {
  var t = _ref.t,
    term = _ref.term,
    a = _ref.a,
    action = _ref.action,
    o = _ref.o,
    orient = _ref.orient;
  var addingHandler = "add".concat(handlerType, "Handler"),
    removingHandler = "remove".concat(handlerType, "Handler");
  var TAO = useTaoContext();
  var permutations = __chunk_4.getPermutations({
    t: t,
    term: term,
    a: a,
    action: action,
    o: o,
    orient: orient
  });
  React.useEffect(function () {
    permutations.forEach(function (trigram) {
      return TAO[addingHandler](trigram, handler);
    });
    return function () {
      permutations.forEach(function (trigram) {
        return TAO[removingHandler](trigram, handler);
      });
    };
  }, dependencies);
}
function useTaoInlineHandler(_ref2, handler, dependencies) {
  var t = _ref2.t,
    term = _ref2.term,
    a = _ref2.a,
    action = _ref2.action,
    o = _ref2.o,
    orient = _ref2.orient;
  useTaoEffect('Inline', {
    t: t,
    term: term,
    a: a,
    action: action,
    o: o,
    orient: orient
  }, handler, dependencies);
}
function useTaoAsyncHandler(_ref3, handler, dependencies) {
  var t = _ref3.t,
    term = _ref3.term,
    a = _ref3.a,
    action = _ref3.action,
    o = _ref3.o,
    orient = _ref3.orient;
  useTaoEffect('Async', {
    t: t,
    term: term,
    a: a,
    action: action,
    o: o,
    orient: orient
  }, handler, dependencies);
}
function useTaoInterceptHandler(_ref4, handler, dependencies) {
  var t = _ref4.t,
    term = _ref4.term,
    a = _ref4.a,
    action = _ref4.action,
    o = _ref4.o,
    orient = _ref4.orient;
  useTaoEffect('Intercept', {
    t: t,
    term: term,
    a: a,
    action: action,
    o: o,
    orient: orient
  }, handler, dependencies);
}
function useTaoDataContext(name) {
  var _React$useContext2 = React.useContext(Provider.Context),
    getDataContext = _React$useContext2.getDataContext;
  var dataContext = getDataContext(name);
  if (!dataContext) {
    return;
  }
  return React.useContext(dataContext);
}

exports.Provider = Provider.default;
exports.createContextHandler = __chunk_5.createContextHandler;
exports.DataHandler = DataHandler.default;
exports.RenderHandler = RenderHandler.default;
exports.SwitchHandler = SwitchHandler.default;
exports.withContext = withContext.default;
exports.DataConsumer = DataConsumer;
exports.useTaoAsyncHandler = useTaoAsyncHandler;
exports.useTaoContext = useTaoContext;
exports.useTaoDataContext = useTaoDataContext;
exports.useTaoInlineHandler = useTaoInlineHandler;
exports.useTaoInterceptHandler = useTaoInterceptHandler;
//# sourceMappingURL=index.js.map
