'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-a0ad16ae.js');
var Adapter = require('./Adapter.js');
require('cartesian');
var React = _interopDefault(require('react'));
require('@tao.js/core');
var PropTypes = _interopDefault(require('prop-types'));

var objectWithoutPropertiesLoose = __chunk_1.createCommonjsModule(function (module) {
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
module.exports = _objectWithoutPropertiesLoose, module.exports.__esModule = true, module.exports["default"] = module.exports;
});

__chunk_1.unwrapExports(objectWithoutPropertiesLoose);

var objectWithoutProperties = __chunk_1.createCommonjsModule(function (module) {
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
module.exports = _objectWithoutProperties, module.exports.__esModule = true, module.exports["default"] = module.exports;
});

var _objectWithoutProperties = __chunk_1.unwrapExports(objectWithoutProperties);

var assertThisInitialized = __chunk_1.createCommonjsModule(function (module) {
function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}
module.exports = _assertThisInitialized, module.exports.__esModule = true, module.exports["default"] = module.exports;
});

__chunk_1.unwrapExports(assertThisInitialized);

var possibleConstructorReturn = __chunk_1.createCommonjsModule(function (module) {
var _typeof = __chunk_1.require$$0["default"];

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return assertThisInitialized(self);
}
module.exports = _possibleConstructorReturn, module.exports.__esModule = true, module.exports["default"] = module.exports;
});

var _possibleConstructorReturn = __chunk_1.unwrapExports(possibleConstructorReturn);

var getPrototypeOf = __chunk_1.createCommonjsModule(function (module) {
function _getPrototypeOf(o) {
  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  }, module.exports.__esModule = true, module.exports["default"] = module.exports;
  return _getPrototypeOf(o);
}
module.exports = _getPrototypeOf, module.exports.__esModule = true, module.exports["default"] = module.exports;
});

var _getPrototypeOf = __chunk_1.unwrapExports(getPrototypeOf);

var setPrototypeOf = __chunk_1.createCommonjsModule(function (module) {
function _setPrototypeOf(o, p) {
  module.exports = _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  }, module.exports.__esModule = true, module.exports["default"] = module.exports;
  return _setPrototypeOf(o, p);
}
module.exports = _setPrototypeOf, module.exports.__esModule = true, module.exports["default"] = module.exports;
});

__chunk_1.unwrapExports(setPrototypeOf);

var inherits = __chunk_1.createCommonjsModule(function (module) {
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass) setPrototypeOf(subClass, superClass);
}
module.exports = _inherits, module.exports.__esModule = true, module.exports["default"] = module.exports;
});

var _inherits = __chunk_1.unwrapExports(inherits);

var _excluded = ["adapter", "children"];
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
var DUMMY_STATE = {};
var Reactor = /*#__PURE__*/function (_React$Component) {
  _inherits(Reactor, _React$Component);
  function Reactor(props) {
    __chunk_1._classCallCheck(this, Reactor);
    return _callSuper(this, Reactor, [props]); // this._adapter = adapter;
  }
  __chunk_1._createClass(Reactor, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var adapter = this.props.adapter;
      adapter.registerReactor(this, this.onNotifyChange.bind(this));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var adapter = this.props.adapter;
      adapter && adapter.unregisterReactor && adapter.unregisterReactor(this);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var adapter = this.props.adapter;
      if (adapter !== prevProps.adapter) {
        prevProps.adapter.unregisterReactor(this);
        adapter.registerReactor(this, this.onNotifyChange.bind(this));
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return true;
    }
    //   // TODO: Implement this properly
    //   // CURRENTLY: this.props.adapter already has the changes after a TAO Handler
    //   const { adapter, children, ...props } = this.props;
    //   if (adapter !== nextProps.adapter) {
    //     return true;
    //   }
    //   if (
    //     (adapter.current == null && nextProps.adapter.current != null) ||
    //     (adapter.current != null && nextProps.adapter.current == null)
    //   ) {
    //     return true;
    //   }
    //   if (adapter.current == null && nextProps.adapter.current == null) {
    //     return false;
    //   }
    //   // TODO: if the term, action, orient or any other props change for the same
    //   //  Component, if this returns `false` will React still call render on the
    //   //  Component
    //   if (adapter.current.Component !== nextProps.adapter.current.Component) {
    //     return true;
    //   }
    //   // TODO: figure out if need to perform props equality check
    //   //  - by checking if updated props get sent to re-rendered child
    //   return false;
    // }
  }, {
    key: "onNotifyChange",
    value: function onNotifyChange() {
      this.setState(DUMMY_STATE);
    }
  }, {
    key: "render",
    value: function render() {
      // NOTE: Currently swallows any children
      var _this$props = this.props,
        adapter = _this$props.adapter,
        children = _this$props.children,
        props = _objectWithoutProperties(_this$props, _excluded);
      if (!adapter.current) {
        return null;
      }
      var _adapter$current = adapter.current,
        ComponentHandler = _adapter$current.ComponentHandler,
        tao = _adapter$current.tao,
        childProps = _adapter$current.props;
      if (!ComponentHandler) {
        return null;
      }
      return React.createElement(ComponentHandler, __chunk_1._objectSpread({}, tao, props, childProps));
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        adapter: PropTypes.instanceOf(Adapter).isRequired
      };
    }
  }]);
  return Reactor;
}(React.Component);

module.exports = Reactor;
//# sourceMappingURL=Reactor.js.map
